/**************************************************************

File: Formel_NTC10k_ref10k_RN001.c

Reference Resistance: 10k

**************************************************************/

#include <stdint.h>



int16_t Formel_NTC10k_ref10k_RN001( uint16_t ADC_input )
{
    
    // Linear Approximation with max deviation of 0.2C between -34.6C & 110.4C )
    // Input:  ADC Value with 10-Bit Resolution
    // Output: Temperature in C * 10
    
    int16_t tmp16;
    
    if(      ADC_input < 61  ) return( -32768 );								// circuit interruption
    
    else if( ADC_input < 88  ) tmp16 = (int16_t)ADC_input * 11 / 4 - 511;		// from -34.6C to -27.4C
    else if( ADC_input < 126 ) tmp16 = (int16_t)ADC_input * 2 - 445;   		    // to -19.7C
    else if( ADC_input < 182 ) tmp16 = (int16_t)ADC_input * 25 / 16 - 389;	    // to -10.8C
    else if( ADC_input < 246 ) tmp16 = (int16_t)ADC_input * 5 / 4 - 332;        // to -2.5C
                                                                              
    else if( ADC_input < 404 ) tmp16 = (int16_t)ADC_input * 17 / 16 - 283;      // to 14.3C
    else if( ADC_input < 571 ) tmp16 = (int16_t)ADC_input - 261;      	        // to 31.1C
    else if( ADC_input < 670 ) tmp16 = (int16_t)ADC_input * 9 / 8 -330;    	    // to 42.4C
    else if( ADC_input < 727 ) tmp16 = (int16_t)ADC_input * 5 / 4 - 411;    	// to 49.8C
    else if( ADC_input < 796 ) tmp16 = (int16_t)ADC_input * 25 / 16 - 637;	    // to 60.8C
    else if( ADC_input < 849 ) tmp16 = (int16_t)ADC_input * 2 - 984;	        // to 71.4C
    else if( ADC_input < 884 ) tmp16 = (int16_t)ADC_input * 5 / 2 - 1406;       // to 80.1C
                                                                               
    else if( ADC_input < 915 ) tmp16 = (int16_t)ADC_input * 13 / 4 - 2067;      // to 90.5C
    else if( ADC_input < 938 ) tmp16 = (int16_t)ADC_input * 17 / 4 - 2980;      // to 100.4C
    else if( ADC_input < 956 ) tmp16 = (int32_t)ADC_input * 45 / 8 - 4269;      // to 110.4C
    
    else return( 32767 );                                                       // short circuit
    return( tmp16 );
}
